
package bank.client;


/*
 * Copyright (C) 1998 OGIS-RI. All Rights Reserverd.
 *
 */

import org.omg.CORBA.*;

import bank.boundary.*;
import bank.corba.*;
import bank.util.*;

/**
 *CORBAgpۂ̃TuVXeoE_̃NCAg̎
 *#pattern: Facade
 *#patten: Proxy
 *#pattern: Wrapper 
 *
 *@see bank.server.CorbaBankApplicationManagerS
 *@version 3.2 
 *@author Masashi Umezawa
 */ 
 
public class CorbaBankApplicationManagerC implements BankApplicationManagerInterface{
	protected ORB orb;
	protected CorbaBankApplicationManagerInterface corbaBankAppIf;








/**
 * 
 */
public CorbaBankApplicationManagerC ( ) {
	orb = ORB.init();
	corbaBankAppIf = CorbaBankApplicationManagerInterfaceHelper.bind(orb,"BankApplicationManager");
	System.out.println("##bind succeeded"); 
}
public int checkBalanceAccount(int accountNumber ) throws bank.util.AccountNotFoundException{
	int result = 0;
	try{
		result =  corbaBankAppIf.checkBalanceAccount(accountNumber);
	} catch (bank.corba.AccountNotFoundException e){
		throw new bank.util.AccountNotFoundException();
	}
	return result;		
}	
public int depositAccount(int accountNumber,int amount) throws bank.util.AccountNotFoundException{
	int result = 0;
	try{
		result = corbaBankAppIf.depositAccount(accountNumber, amount);
	} catch (bank.corba.AccountNotFoundException e){
		throw new bank.util.AccountNotFoundException();
	}	
	return result;	
}	
/**
 *BCorbabankApplicationC̃CX^XԂ
 *#pattern: Singleton
 */
public static CorbaBankApplicationManagerC getDefault() {
	return (CorbaBankApplicationManagerC)(SingletonFactory.defaultInstance("bank.client.CorbaBankApplicationManagerC"));;
}
public boolean verifyAccount(int accountNumber){
	return corbaBankAppIf.verifyAccount(accountNumber);
}	
public int withdrawAccount(int accountNumber,int amount) throws bank.util.AccountNotFoundException{
	int result = 0;
	try{
		result = corbaBankAppIf.withdrawAccount(accountNumber, amount);
	} catch (bank.corba.AccountNotFoundException e){
		throw new bank.util.AccountNotFoundException();
	}
	return result;		
}	
}