
package bank.corba;


/**
<p>
<ul>
<li> <b>Java Class</b> bank.corba.CorbaBankApplicationManagerInterfaceHelper
<li> <b>Source File</b> bank/corba/CorbaBankApplicationManagerInterfaceHelper.java
<li> <b>IDL Source File</b> bankif.idl
<li> <b>IDL Absolute Name</b> ::bank::corba::CorbaBankApplicationManagerInterface
<li> <b>Repository Identifier</b> IDL:bank/corba/CorbaBankApplicationManagerInterface:1.0
</ul>
<b>IDL definition:</b>
<pre>
	interface CorbaBankApplicationManagerInterface {
	  boolean verifyAccount(
		in long accountNumber
	  );
	  long depositAccount(
		in long accountNumber,
		in long amount
	  )
	  raises(
		::bank::corba::AccountNotFoundException
	  );
	  long withdrawAccount(
		in long accountNumber,
		in long amount
	  )
	  raises(
		::bank::corba::AccountNotFoundException
	  );
	  long checkBalanceAccount(
		in long accountNumber
	  )
	  raises(
		::bank::corba::AccountNotFoundException
	  );
	};
</pre>
</p>
*/
abstract public class CorbaBankApplicationManagerInterfaceHelper {
  private static org.omg.CORBA.TypeCode _type;


  private static org.omg.CORBA.ORB _orb() {
	return org.omg.CORBA.ORB.init();
  }    
  public static bank.corba.CorbaBankApplicationManagerInterface bind(org.omg.CORBA.ORB orb) {
	return bind(orb, null, null, null);
  }    
  public static bank.corba.CorbaBankApplicationManagerInterface bind(org.omg.CORBA.ORB orb, java.lang.String name) {
	return bind(orb, name, null, null);
  }    
  public static bank.corba.CorbaBankApplicationManagerInterface bind(org.omg.CORBA.ORB orb, java.lang.String name, java.lang.String host, org.omg.CORBA.BindOptions options) {
	return narrow(orb.bind(id(), name, host, options), true);
  }    
  public static bank.corba.CorbaBankApplicationManagerInterface extract(org.omg.CORBA.Any any) {
	if(!any.type().equal(type())) {
	  throw new org.omg.CORBA.BAD_TYPECODE();
	}
	return read(any.create_input_stream());
  }    
  public static java.lang.String id() {
	return "IDL:bank/corba/CorbaBankApplicationManagerInterface:1.0";
  }    
  public static void insert(org.omg.CORBA.Any any, bank.corba.CorbaBankApplicationManagerInterface value) {
	org.omg.CORBA.portable.OutputStream output = any.create_output_stream();
	write(output, value);
	any.read_value(output.create_input_stream(), type());
  }    
  public static bank.corba.CorbaBankApplicationManagerInterface narrow(org.omg.CORBA.Object object) {
	return narrow(object, false);
  }    
  private static bank.corba.CorbaBankApplicationManagerInterface narrow(org.omg.CORBA.Object object, boolean is_a) {
	if(object == null) {
	  return null;
	}
	if(object instanceof bank.corba.CorbaBankApplicationManagerInterface) {
	  return (bank.corba.CorbaBankApplicationManagerInterface) object;
	}
	if(is_a || object._is_a(id())) {
	  bank.corba._st_CorbaBankApplicationManagerInterface result = (bank.corba._st_CorbaBankApplicationManagerInterface)new bank.corba._st_CorbaBankApplicationManagerInterface();
	  ((org.omg.CORBA.portable.ObjectImpl) result)._set_delegate
		(((org.omg.CORBA.portable.ObjectImpl) object)._get_delegate());
	  ((org.omg.CORBA.portable.ObjectImpl) result._this())._set_delegate
		(((org.omg.CORBA.portable.ObjectImpl) object)._get_delegate());
	  return (bank.corba.CorbaBankApplicationManagerInterface) result._this();
	}
	return null;
  }    
  public static bank.corba.CorbaBankApplicationManagerInterface read(org.omg.CORBA.portable.InputStream _input) {
	return bank.corba.CorbaBankApplicationManagerInterfaceHelper.narrow(_input.read_Object(), true);
  }    
  public static org.omg.CORBA.TypeCode type() {
	if(_type == null) {
	  _type = _orb().create_interface_tc(id(), "CorbaBankApplicationManagerInterface");
	}
	return _type;
  }    
  public static void write(org.omg.CORBA.portable.OutputStream _output, bank.corba.CorbaBankApplicationManagerInterface value) {
	_output.write_Object(value);
  }    
}