
package bank.corba;


/**
<p>
<ul>
<li> <b>Java Class</b> bank.corba._CorbaBankApplicationManagerInterfaceImplBase
<li> <b>Source File</b> bank/corba/_CorbaBankApplicationManagerInterfaceImplBase.java
<li> <b>IDL Source File</b> bankif.idl
<li> <b>IDL Absolute Name</b> ::bank::corba::CorbaBankApplicationManagerInterface
<li> <b>Repository Identifier</b> IDL:bank/corba/CorbaBankApplicationManagerInterface:1.0
</ul>
<b>IDL definition:</b>
<pre>
	interface CorbaBankApplicationManagerInterface {
	  boolean verifyAccount(
		in long accountNumber
	  );
	  long depositAccount(
		in long accountNumber,
		in long amount
	  )
	  raises(
		::bank::corba::AccountNotFoundException
	  );
	  long withdrawAccount(
		in long accountNumber,
		in long amount
	  )
	  raises(
		::bank::corba::AccountNotFoundException
	  );
	  long checkBalanceAccount(
		in long accountNumber
	  )
	  raises(
		::bank::corba::AccountNotFoundException
	  );
	};
</pre>
</p>
*/
abstract public class _CorbaBankApplicationManagerInterfaceImplBase extends org.omg.CORBA.portable.Skeleton implements bank.corba.CorbaBankApplicationManagerInterface {
  protected bank.corba.CorbaBankApplicationManagerInterface _wrapper = null;
  private static java.lang.String[] __ids = {
	"IDL:bank/corba/CorbaBankApplicationManagerInterface:1.0"
  };


  public _CorbaBankApplicationManagerInterfaceImplBase() {
  }    
  protected _CorbaBankApplicationManagerInterfaceImplBase(java.lang.String name) {
	super(name);
  }    
  public static boolean _execute(bank.corba.CorbaBankApplicationManagerInterface _self, int _method_id, org.omg.CORBA.portable.InputStream _input, org.omg.CORBA.portable.OutputStream _output) {
	switch(_method_id) {
	case 0: {
	  int accountNumber;
	  accountNumber = _input.read_long();
	  boolean _result = _self.verifyAccount(accountNumber);
	  _output.write_boolean(_result);
	  return false;
	}
	case 1: {
	  try {
		int accountNumber;
		accountNumber = _input.read_long();
		int amount;
		amount = _input.read_long();
		int _result = _self.depositAccount(accountNumber,amount);
		_output.write_long(_result);
	  }
	  catch(bank.corba.AccountNotFoundException _exception) {
		bank.corba.AccountNotFoundExceptionHelper.write(_output, _exception);
		return true;
	  }
	  return false;
	}
	case 2: {
	  try {
		int accountNumber;
		accountNumber = _input.read_long();
		int amount;
		amount = _input.read_long();
		int _result = _self.withdrawAccount(accountNumber,amount);
		_output.write_long(_result);
	  }
	  catch(bank.corba.AccountNotFoundException _exception) {
		bank.corba.AccountNotFoundExceptionHelper.write(_output, _exception);
		return true;
	  }
	  return false;
	}
	case 3: {
	  try {
		int accountNumber;
		accountNumber = _input.read_long();
		int _result = _self.checkBalanceAccount(accountNumber);
		_output.write_long(_result);
	  }
	  catch(bank.corba.AccountNotFoundException _exception) {
		bank.corba.AccountNotFoundExceptionHelper.write(_output, _exception);
		return true;
	  }
	  return false;
	}
	}
	throw new org.omg.CORBA.MARSHAL();
  }    
  public boolean _execute(org.omg.CORBA.portable.MethodPointer method, org.omg.CORBA.portable.InputStream input, org.omg.CORBA.portable.OutputStream output) {
	switch(method.interface_id) {
	case 0: {
	  return bank.corba._CorbaBankApplicationManagerInterfaceImplBase._execute(_this(), method.method_id, input, output); 
	}
	}
	throw new org.omg.CORBA.MARSHAL();
  }    
  public java.lang.String[] _ids() {
	return __ids;
  }    
  public org.omg.CORBA.portable.MethodPointer[] _methods() {
	org.omg.CORBA.portable.MethodPointer[] methods = {
	  new org.omg.CORBA.portable.MethodPointer("verifyAccount", 0, 0),
	  new org.omg.CORBA.portable.MethodPointer("depositAccount", 0, 1),
	  new org.omg.CORBA.portable.MethodPointer("withdrawAccount", 0, 2),
	  new org.omg.CORBA.portable.MethodPointer("checkBalanceAccount", 0, 3),
	};
	return methods;
  }    
  public bank.corba.CorbaBankApplicationManagerInterface _this() {
	return this;
  }    
}