
package bank.corba;


/**
<p>
<ul>
<li> <b>Java Class</b> bank.corba._st_CorbaBankApplicationManagerInterface
<li> <b>Source File</b> bank/corba/_st_CorbaBankApplicationManagerInterface.java
<li> <b>IDL Source File</b> bankif.idl
<li> <b>IDL Absolute Name</b> ::bank::corba::CorbaBankApplicationManagerInterface
<li> <b>Repository Identifier</b> IDL:bank/corba/CorbaBankApplicationManagerInterface:1.0
</ul>
<b>IDL definition:</b>
<pre>
	interface CorbaBankApplicationManagerInterface {
	  boolean verifyAccount(
		in long accountNumber
	  );
	  long depositAccount(
		in long accountNumber,
		in long amount
	  )
	  raises(
		::bank::corba::AccountNotFoundException
	  );
	  long withdrawAccount(
		in long accountNumber,
		in long amount
	  )
	  raises(
		::bank::corba::AccountNotFoundException
	  );
	  long checkBalanceAccount(
		in long accountNumber
	  )
	  raises(
		::bank::corba::AccountNotFoundException
	  );
	};
</pre>
</p>
*/
public class _st_CorbaBankApplicationManagerInterface extends org.omg.CORBA.portable.ObjectImpl implements bank.corba.CorbaBankApplicationManagerInterface {
  protected bank.corba.CorbaBankApplicationManagerInterface _wrapper = null;
  private static java.lang.String[] __ids = {
	"IDL:bank/corba/CorbaBankApplicationManagerInterface:1.0"
  };


  public java.lang.String[] _ids() {
	return __ids;
  }    
  public bank.corba.CorbaBankApplicationManagerInterface _this() {
	return this;
  }    
  /**
  <p>
  Operation: <b>::bank::corba::CorbaBankApplicationManagerInterface::checkBalanceAccount</b>.
  <pre>
	long checkBalanceAccount(
	  in long accountNumber
	)
	raises(
	  ::bank::corba::AccountNotFoundException
	);
  </pre>
  </p>
  */
  public int checkBalanceAccount(
	int accountNumber
  ) throws
	bank.corba.AccountNotFoundException {
	try {
	  org.omg.CORBA.portable.OutputStream _output = this._request("checkBalanceAccount", true);
	  _output.write_long(accountNumber);
	  org.omg.CORBA.StringHolder _exception_id = new org.omg.CORBA.StringHolder();
	  org.omg.CORBA.portable.InputStream _input = this._invoke(_output, _exception_id);
	  if(_exception_id.value != null) {
		if(_exception_id.value.equals(bank.corba.AccountNotFoundExceptionHelper.id())) {
		  throw bank.corba.AccountNotFoundExceptionHelper.read(_input);
		}
		throw new org.omg.CORBA.MARSHAL
		  ("Unexpected User Exception: " + _exception_id.value);
	  }
	  int _result;
	  _result = _input.read_long();
	  return _result;
	}
	catch(org.omg.CORBA.TRANSIENT _exception) {
	  return checkBalanceAccount(
		accountNumber
	  );
	}
  }    
  /**
  <p>
  Operation: <b>::bank::corba::CorbaBankApplicationManagerInterface::depositAccount</b>.
  <pre>
	long depositAccount(
	  in long accountNumber,
	  in long amount
	)
	raises(
	  ::bank::corba::AccountNotFoundException
	);
  </pre>
  </p>
  */
  public int depositAccount(
	int accountNumber,
	int amount
  ) throws
	bank.corba.AccountNotFoundException {
	try {
	  org.omg.CORBA.portable.OutputStream _output = this._request("depositAccount", true);
	  _output.write_long(accountNumber);
	  _output.write_long(amount);
	  org.omg.CORBA.StringHolder _exception_id = new org.omg.CORBA.StringHolder();
	  org.omg.CORBA.portable.InputStream _input = this._invoke(_output, _exception_id);
	  if(_exception_id.value != null) {
		if(_exception_id.value.equals(bank.corba.AccountNotFoundExceptionHelper.id())) {
		  throw bank.corba.AccountNotFoundExceptionHelper.read(_input);
		}
		throw new org.omg.CORBA.MARSHAL
		  ("Unexpected User Exception: " + _exception_id.value);
	  }
	  int _result;
	  _result = _input.read_long();
	  return _result;
	}
	catch(org.omg.CORBA.TRANSIENT _exception) {
	  return depositAccount(
		accountNumber,
		amount
	  );
	}
  }    
  /**
  <p>
  Operation: <b>::bank::corba::CorbaBankApplicationManagerInterface::verifyAccount</b>.
  <pre>
	boolean verifyAccount(
	  in long accountNumber
	);
  </pre>
  </p>
  */
  public boolean verifyAccount(
	int accountNumber
  ) {
	try {
	  org.omg.CORBA.portable.OutputStream _output = this._request("verifyAccount", true);
	  _output.write_long(accountNumber);
	  org.omg.CORBA.portable.InputStream _input = this._invoke(_output, null);
	  boolean _result;
	  _result = _input.read_boolean();
	  return _result;
	}
	catch(org.omg.CORBA.TRANSIENT _exception) {
	  return verifyAccount(
		accountNumber
	  );
	}
  }    
  /**
  <p>
  Operation: <b>::bank::corba::CorbaBankApplicationManagerInterface::withdrawAccount</b>.
  <pre>
	long withdrawAccount(
	  in long accountNumber,
	  in long amount
	)
	raises(
	  ::bank::corba::AccountNotFoundException
	);
  </pre>
  </p>
  */
  public int withdrawAccount(
	int accountNumber,
	int amount
  ) throws
	bank.corba.AccountNotFoundException {
	try {
	  org.omg.CORBA.portable.OutputStream _output = this._request("withdrawAccount", true);
	  _output.write_long(accountNumber);
	  _output.write_long(amount);
	  org.omg.CORBA.StringHolder _exception_id = new org.omg.CORBA.StringHolder();
	  org.omg.CORBA.portable.InputStream _input = this._invoke(_output, _exception_id);
	  if(_exception_id.value != null) {
		if(_exception_id.value.equals(bank.corba.AccountNotFoundExceptionHelper.id())) {
		  throw bank.corba.AccountNotFoundExceptionHelper.read(_input);
		}
		throw new org.omg.CORBA.MARSHAL
		  ("Unexpected User Exception: " + _exception_id.value);
	  }
	  int _result;
	  _result = _input.read_long();
	  return _result;
	}
	catch(org.omg.CORBA.TRANSIENT _exception) {
	  return withdrawAccount(
		accountNumber,
		amount
	  );
	}
  }    
}