
package bank.gui;


/*
 * Copyright (C) 1998 OGIS-RI. All Rights Reserverd.
 *
 */

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

import bank.util.*;
import bank.manager.*;
import bank.state.*;

/**
 *ATM̉ʂ킷r[NX
 *#pattern: Command
 *#pattern MVC
 *#pattern Builder
 *
 *@see bank.gui.Command
 *@see bank.client.AtmGui
 *@see bank.gui.UiBuilder
 *@version 3.2 
 *@author Masashi Umezawa
 */
public class AtmGuiView extends ExtendedApplet implements Observer{
	protected AtmGuiState state;
	protected AtmGuiLogic logic;
	
	protected TextField accountNumField;
	protected TextField moneyField;
	protected Label message;
	protected Label balanceMessage;
	protected Panel rightPanel;
	protected Panel leftPanel;










protected void build(){
	GridBagLayout gb = new GridBagLayout();
	setLayout(gb);
	leftPanel = buildLeftPanel();	
	rightPanel = buildRightPanel();
	builder.setGridBagLayout(0,0,1,1,leftPanel,gb,GridBagConstraints.BOTH);
	builder.setGridBagLayout(1,0,1,1,rightPanel,gb,GridBagConstraints.BOTH);
	add(leftPanel);
	add(rightPanel);
}
private Panel buildAccountIdAskPanel(){
	builder.makeLabel("ԍ͂ĉ");
	accountNumField = builder.makeTextField(10);
	builder.makeOKButton(this.getAtmGuiLogic());
	builder.makeCancelButton(this.getAtmGuiLogic());
	return builder.buildWith(new  GridLayout(4,1,10,10));
}
private Panel buildAtmEnterPanel() {
	builder.makeOKButton("ATM ʂ", this.getAtmGuiLogic());
	return builder.buildWith(new GridLayout(3,1,10,10));
}
private Panel buildAtmMenuPanel() {
	AtmGuiLogic lo = this.getAtmGuiLogic();
	bindButtonCommand("", AtmGuiCommand.DEPOSIT, lo);
	bindButtonCommand("o", AtmGuiCommand.WITHDRAW, lo);
	bindButtonCommand("cƉ", AtmGuiCommand.BALANCE, lo);
	builder.makeOKButton("ATM ʂ", lo);
	return builder.buildWith(new GridLayout(4,1,10,10));
}
private Panel buildBlankPanel(){
	return new Panel();
}
private Panel buildInputErrorPanel(){
	builder.makeLabel("̓G[ł!");
	builder.makeLabel("  ");
	builder.makeOKButton(this.getAtmGuiLogic());
	return builder.buildWith(new GridLayout(4,1,10,10));
}
private Panel buildLeftPanel() {
	Panel panel = new Panel();
	panel.setLayout(new CardLayout());
	panel.add("AtmEnter",buildAtmEnterPanel());
	panel.add("Blank",buildBlankPanel());
	panel.add("AtmMenu",buildAtmMenuPanel());
	return panel;
}
private Panel buildMoneyAskPanel(){
	message = builder.makeLabel("");
	moneyField = builder.makeTextField(10);
	builder.makeOKButton(this.getAtmGuiLogic());
	return builder.buildWith(new  GridLayout(4,1,10,10));
}
private Panel buildResultPanel(){
	balanceMessage = builder.makeLabel("");
	builder.makePanel(new FlowLayout());
	builder.makeOKButton(this.getAtmGuiLogic());
	return builder.buildWith(new GridLayout(3,1,10,10));
}
private Panel buildRightPanel() {
	Panel panel = new Panel();
	panel.setLayout(new CardLayout());
	panel.add("Welcome",buildWelcomePanel());
	panel.add("Blank",buildBlankPanel());
	panel.add("AccountIdAsk",buildAccountIdAskPanel());
	panel.add("InputError",buildInputErrorPanel());
	panel.add("MoneyAsk",buildMoneyAskPanel());
	panel.add("Result",buildResultPanel());
	return panel;
}
private Panel buildWelcomePanel() {
	builder.makeLabel("I[WXsւ悤");
	builder.makeLabel("ATM ʂւĂ");
	return builder.buildWith(new FlowLayout(FlowLayout.CENTER,10,10));
}
protected void clearInputData(){
	accountNumField.setText("");
	moneyField.setText("");
}
protected void displayLeftView(String kind){
	((CardLayout)getLayoutManager(leftPanel)).show(leftPanel,kind);
	//System.out.println("displaying: L:" + kind);
}
protected void displayRightView(String kind){
	((CardLayout)getLayoutManager(rightPanel)).show(rightPanel,kind);
	//System.out.println("displaying: R:" + kind);
}
/**
 * ԍ̒l𓾂
 * ͂sȏꍇ-1Ԃ
 * @return int
 */
public int getAccountNumber() {
	String accNum = accountNumField.getText();
	try{
		return Integer.parseInt(accNum);
	} catch (NumberFormatException e) {
		return -1;
	}		
}
/**
 * 
 * @return bank.gui.AccountGuiLogic
 */
public AtmGuiLogic getAtmGuiLogic() {
	return logic;
}
protected LayoutManager getLayoutManager(Container cont){
	return cont.getLayout();
}
public int getMoney(){
	String money = moneyField.getText();
	try{
		return Integer.parseInt(money);
	} catch (NumberFormatException e) {
		return -1;
	}		
}
public Dimension getSize() {
	return new Dimension(500,180);
}
public String getTitle() {
	return "Atm Gui";
}
public static void main(String args[]) {
	ExtendedApplet.openApplication(new AtmGuiView());
}
protected Command makeCommand(short commandKind, Object callback) {
	return new AtmGuiCommand(callback, commandKind); 
}
/**
 * 
 * @param logic bank.gui.AtmGuiLogic
 */
public void setAtmGuiLogic(AtmGuiLogic logic) {
	this.logic = logic;
}
/**
 * X[pNXExtendedAppletinit()Ă΂tbN\bh
 */
protected void setInitValues(){
	if(!isApplication){
		String managerCls;
		AtmGuiState state = new AtmGuiState();
		managerCls = this.getParameter("managerClass");	
		if(managerCls == null || managerCls.equals("") ){
			managerCls = "bank.manager.BankApplicationManager";
		}
		logic = new AtmGuiLogic(this,state);	
		logic.initManager(managerCls);
	}	
}
public void showAccountIdAskingView(){
	displayLeftView("Blank");
	displayRightView("AccountIdAsk");
}
public void showAccountNotFoundView(){
	this.showInputErrorView();
}
public void showAccountOperationAskingView(){
	displayLeftView("AtmMenu");
	displayRightView("Blank");
}
public void showCheckBalanceFailureView(){
	this.showInputErrorView();
}	
public void showDepositFailureView(){
	this.showInputErrorView();
}	
public void showDepositView(){
	displayRightView("MoneyAsk");
	message.setText("z");
}
public void showInputErrorView(){
	displayRightView("InputError");
	displayLeftView("Blank");
}
public void showOverWithdrawView(){
	this.showInputErrorView();
}	
public void showResultView( AtmGuiStateInterface newState){
	displayRightView("Result");
	displayLeftView("Blank");
	int balance = newState.getBalance();
	balanceMessage.setText("݂̎c" + balance + "~ł");
}
public void showStartView(){
	displayLeftView("AtmEnter");
	displayRightView("Welcome");
	this.clearInputData();
}
public void showWithdrawFailureView(){
	this.showInputErrorView();
}	
public void showWithdrawView(){
	displayRightView("MoneyAsk");
	message.setText("oz");
}
/**
 * AtmGuiStatȅԕωɂĂ΂update\bh
 * #pattern: Observer
 * @param o java.util.Observable
 * @param arg java.lang.Object
 */
public void update(Observable o, Object arg) {
	AtmGuiStateInterface newState = (AtmGuiStateInterface)arg;
	
	System.out.println("##current state: " + newState);
	
	if (newState instanceof AtmStartingState){
		this.showStartView();
	}	else if ( newState instanceof AccountIdAskingState ){
		this.showAccountIdAskingView(); 
	} else if ( newState instanceof AccountOperationAskingState ){
		this.showAccountOperationAskingView();
	} else if ( newState instanceof AccountDepositingState ){
		this.showDepositView();
	} else if ( newState instanceof AccountWithdrawingState ){
		this.showWithdrawView();
	} else if ( newState instanceof ShowingAccountState ){
		this.showResultView( newState );
	} else if ( newState instanceof AccountNotFoundState ){
		this.showAccountNotFoundView();
	} else if ( newState instanceof DepositFailureState ){
		this.showDepositFailureView();
	} else if ( newState instanceof WithdrawFailureState ){
		this.showWithdrawFailureView();
	} else if ( newState instanceof CheckBalanceFailureState ){
		this.showCheckBalanceFailureView();
	} else if ( newState instanceof OverWithdrawState ){
		this.showOverWithdrawView();
	} else {
		System.out.println("unexpected state for this view");
		this.showStartView();
	}
		
}
}