
package bank.manager;


/*
 * Copyright (C) 1998 OGIS-RI. All Rights Reserverd.
 *
 */

import bank.model.*;
import bank.storage.*;
import bank.util.*;

/**
 *s̃CX^XNCAgɕԋp
 *̒lωƂɎIɕۑ悤Negotiations
 *#pattern: Facade
 *#toDo: Negotiation𕪊
 *
 *@see bank.manager.DomainFinder
 *@version 3.2 
 *@author Masashi Umezawa
 */ 
public class AccountFinder extends DomainFinder{
	









/**
 * ԍɑΉ
 * ꂽCX^Xɑ΂Strager̐ݒs
 * @exception bank.util.AccountNotFoundException
 */
public Account find(int accountNo) throws AccountNotFoundException{
	Account account;
		try {
	    this.prepareDbAdaptor(accountNo);
	    account = (Account)adaptor.retrieve(accountNo);
	    this.prepareStorager(account, adaptor);
	    return account;
		} catch ( NotFoundException e) {
	    throw new AccountNotFoundException();
		}
}
/**
 * DbAdaptorɂgp
 * @return java.lang.Object
 */
protected Object getDefaultDomainObject( ){
	return new Account();
}	 
protected void prepareDbAdaptor(int accountNo) {
		Account domain = (Account)(this.getDefaultDomainObject());
		if(dbAdaptorCreatePolicy != null){
			adaptor = (DbAdaptor)dbAdaptorCreatePolicy.createDbAdaptor(accountNo, domain);
			if(adaptor instanceof JdbcRdbAdaptor){
				this.setSpecificSettingsOf("jdbc");
			}	
		}	else {
			adaptor = new TextFileDbAdaptor(domain);
		}	
				
}
protected void prepareDbAdaptor(Object condition){
	if(condition instanceof Integer){
		this.prepareDbAdaptor(((Integer)condition).intValue());
	}	
}                        
/**
 * eDbAdaptorL̏ݒs
 */
protected void setSpecificSettingsOf(String environmentKind) {
	if(isSpecificSet == false){
		if(environmentKind.equals("jdbc")){
			String result;
			JdbcRdbAdaptor jdbcAdaptor = (JdbcRdbAdaptor)adaptor;
			result = System.getProperty("storage.jdbc.bank.driverKind");
			if ( result == null ) { jdbcAdaptor.setDriverKind("sun.jdbc.odbc.JdbcOdbcDriver");}
		 	else { jdbcAdaptor.setDriverKind(result);}
	  
		  result = System.getProperty("storage.jdbc.bank.dbLocation");
		  if ( result == null ) { jdbcAdaptor.setDbLocation("jdbc:odbc:bank");}
		  else { jdbcAdaptor.setDbLocation(result);}
	  
		  result = System.getProperty("storage.jdbc.bank.username");
	 		if ( result == null ) { jdbcAdaptor.setUsername("");}
	 	 	else { jdbcAdaptor.setUsername(result);}
  
	 		result = System.getProperty("storage.jdbc.bank.password");
	 	 	if ( result == null ) { jdbcAdaptor.setPassword("");}
		  else { jdbcAdaptor.setPassword(result);}
		  
		  jdbcAdaptor.install();
		  
		}
		isSpecificSet = true;	
	}	
}
}