
package bank.model;


/*
 * Copyright (C) 1998 OGIS-RI. All Rights Reserverd.
 *
 */

import java.util.*;
import bank.util.DomainObject;


/**
 *s킷hCf
 *#pattern: MVC
 *
 *@see bank.util.DomainObject  
 *@see bank.util.Identifyable 
 *@see bank.util.StringPrintable
 *@see bank.util.StringParsable
 *@see bank.util.RdbTableMappable   
 *@version 3.2 
 *@author Masashi Umezawa
 */
public class Account extends DomainObject{
	protected int number;
	protected int balance;
	protected Customer customer;












public Account() {
	number = 0;
	balance = 0;
	customer = new Customer();
}
public Account( int number) {
	this.number = number;
}
public Account(int number, Customer customer) {
	this.number = number;
	this.customer = customer;
}
public Account( Customer customer) {
	this.customer = customer;
}
public int checkBalance() {
	return getBalance();
}
public int deposit(int money) {
	int newBalance = getBalance() + money;
	setBalance(newBalance);
	return newBalance;
}
public int getBalance() {
	return this.balance;
}
public Customer getCustomer() {
	return customer;
}
/**
 * Identifyable̎
 * @return int
 * @see bank.util.Identifyable
 */
public int getId()  {
	return this.number;
}
/**
 * Identifyable̎
 * @return java.lang.String
 * @see bank.util.Identifyable
 */
public String getIdString()  {
	return String.valueOf(this.number);
}
public int getNumber() {
	return this.number;
}
/**
 * RdbTableMappable̎
 * @return java.lang.String
 * @see bank.util.RdbTableMappable
 */
public String mapperClassName(){
	return "bank.storage.AccountTableMapper";
}
/**
 * StringParsable̎
 * @return java.lang.String
 * @see bank.util.StringParsable
 */
public Object parseFrom(String lineString)  {
	super.parseFrom(lineString);
	this.number = Integer.parseInt(tokenizer.nextToken());
	this.balance = Integer.parseInt(tokenizer.nextToken());
	this.customer = (Customer)customer.parseFrom(tokenizer.nextToken());
	return this;
}
/**
 * StringPrintable̎
 * @return java.lang.String
 * @see bank.util.StringPrintable
 */
public String printString()  {
	String numberString, balanceString, customerString;
	numberString = String.valueOf(this.number);
	balanceString = String.valueOf(this.balance);
	customerString = customer.printString();
	return numberString + delimiterString() + balanceString
	       + delimiterString() + customerString + delimiterString();
}
public void setBalance(int newBalance) {
	int oldBalance = this.balance;
	this.balance = newBalance;
	
	//changed notification (using observer)
	setChanged();
	notifyObservers((Object)(new Integer(this.number)));
		
	//changed notification (using beans)
	changes.firePropertyChange("balance", new Integer(oldBalance),new Integer(newBalance));
	
}
public void setCustomer(Customer customer) {
	this.customer = customer;
}
public void setNumber(int number) {
	this.number = number;
}
public int withdraw(int money) {
	int newBalance = getBalance() - money;
	setBalance(newBalance);
	return newBalance;
}
}