
package bank.model;


/*
 * Copyright (C) 1998 OGIS-RI. All Rights Reserverd.
 *
 */

import java.util.Observable;
import bank.util.DomainObject;

/**
 *ڋq킷hCf
 *#pattern: MVC
 *
 *@see bank.util.DomainObject  
 *@see bank.util.Identifyable 
 *@see bank.util.StringPrintable
 *@see bank.util.StringParsable
 *@see bank.util.RdbTableMappable 
 *@version 3.2 
 *@author Masashi Umezawa
 */
public class Customer extends DomainObject{
	protected String name;
	protected String address;




public Customer() {
	name = " ";
	address = " ";
}
public Customer(String name, String address) {
	this.name = name;
	this.address = address;
}
/**
 * StringParsable̎
 * @return java.lang.String
 * @see bank.util.StringParsable
 */
public String delimiterString()  {
	return ":";
}                     
public String getAddress() {
	return address;
}
/**
 * Identifyable̎
 * @return int
 * @see bank.util.Identifyable
 */
public int getId()  {
	return (name + address).hashCode();
}
public String getName() {
	return name;
}
/**
 * RdbTableMappable̎
 * @return java.lang.String
 * @see bank.util.RdbTableMappable
 */
public String mapperClassName(){
	return "bank.storage.CustomerTableMapper";
}
/**
 * StringParsable̎
 * @return java.lang.String
 * @see bank.util.StringParsable
 */
public Object parseFrom(String lineString)  {
	super.parseFrom(lineString);
	tokenizer.nextToken();
	this.name = tokenizer.nextToken();
	this.address = tokenizer.nextToken();
	return this;
}
/**
 * StringPrintable̎
 * @return java.lang.String
 * @see bank.util.StringPrintable
 */
public String printString()  {
		return getIdString() + delimiterString() + name + delimiterString()
	   + address + delimiterString();
}
public void setAddress(String address) {
	this.address = address;
}
public void setName(String name) {
	this.name = name;
}
}