
package bank.server;


/*
 * Copyright (C) 1998 OGIS-RI. All Rights Reserverd.
 *
 */


import org.omg.CORBA.*;

import bank.corba.*;
import bank.manager.*;
import bank.util.*;



/**
 *sAvP[V}l[WCORBAɂ
 *ۂ̏bank.manager.BankApplicationManagerɈϏ
 *#pattern: Facade
 *#pattren: Wrapper
 *
 *@see bank.client.CorbaBankApplicationManagerC
 *@see bank.manager.BankApplicationManager
 *@version 3.2 
 *@author Masashi Umezawa
 */ 
public class CorbaBankApplicationManagerS implements CorbaBankApplicationManagerInterfaceOperations {
	protected bank.manager.BankApplicationManager realMgr;








/**
 * BankApplicationManager constructor comment.
 */
public CorbaBankApplicationManagerS() {
	realMgr = bank.manager.BankApplicationManager.getDefault();
}
public  void beLogOn(boolean trueOrFalse) {
	realMgr.beLogOn(trueOrFalse);
}
/**
 * 
 * @return int
 * @param accountNumber int
 */
public int checkBalanceAccount(int accountNumber) throws bank.corba.AccountNotFoundException{
	int balance = 0;
	try{
		balance = realMgr.checkBalanceAccount(accountNumber);
	} catch (bank.util.AccountNotFoundException e){
		throw new bank.corba.AccountNotFoundException();
	}				
	return balance;
}
/**
 * 
 * @return int
 * @param accountNo int
 * @param amount int
 */
public int depositAccount(int accountNumber, int amount) throws bank.corba.AccountNotFoundException{
	int balance = 0;
	try{
		balance = realMgr.depositAccount(accountNumber, amount);
	} catch (bank.util.AccountNotFoundException e){
		throw new bank.corba.AccountNotFoundException();
	}		
	return balance;
}
/**
 *#pattern: Singleton
 */
public static CorbaBankApplicationManagerS getDefault() {
	return (CorbaBankApplicationManagerS)(SingletonFactory.defaultInstance("bank.server.CorbaBankApplicationManagerS"));;
}
/**
 * 
 * @return Account
 * @param accountNum int
 */
public boolean verifyAccount (int accountNum ){
	boolean result;
	result = realMgr.verifyAccount(accountNum);
	return result;
}
/**
 * 
 * @return int
 * @param accountNumber int
 * @param amount int
 */
public int withdrawAccount(int accountNumber, int amount) throws bank.corba.AccountNotFoundException{
	int balance = 0;
	try{
		balance = realMgr.withdrawAccount(accountNumber, amount);
	} catch (bank.util.AccountNotFoundException e){
		throw new bank.corba.AccountNotFoundException();
	}				
	return balance;
}
}