
package bank.state;


/*
 * Copyright (C) 1998 OGIS-RI. All Rights Reserverd.
 *
 */

import bank.gui.*;
import bank.manager.*;
import bank.util.*;

/**
 *ATMʂ̊eԂ킷߂̒ۃNX
 *TuNX́AATMʐڂ̈ԂɑΉ
 *#pattern: State
 *
 *@version 3.2 
 *@author Masashi Umezawa
 */ 
abstract public class BaseAtmGuiState extends State implements AtmGuiStateInterface{
	protected AtmGuiLogic logic;
	
	protected int accountNumber;
	protected int balance;
	









/**
 * 
 * 
 */
public State accept() {
	//default do nothing
	return null;
}
/**
 * 
 * @return bank.state.ATMState
 */
public State beAccountDepositing() {
	return this.changeTo(this.defaultInstance("bank.state.AccountDepositingState"));
}
/**
 * 
 * @return bank.state.ATMState
 */
public State beAccountIdAsking ( ) {
	return this.changeTo(this.defaultInstance("bank.state.AccountIdAskingState"));
}
/**
 * 
 * @return bank.state.ATMState
 */
public State beAccountNotFound() {
	return this.changeTo(this.defaultInstance("bank.state.AccountNotFoundState"));
}
/**
 * 
 * @return bank.state.ATMState
 */
public State beAccountOperationAsking ( ) {
	return this.changeTo(this.defaultInstance("bank.state.AccountOperationAskingState"));
}
/**
 * 
 * @return bank.state.ATMState
 */
public State beAccountWithdrawing() {
	return this.changeTo(this.defaultInstance("bank.state.AccountWithdrawingState"));
}
/**
 * 
 */
public State beAtmStarting() {
	return this.changeTo(this.defaultInstance("bank.state.AtmStartingState"));
}
/**
 * 
 * @return bank.state.ATMState
 */
public State beCheckBalanceFailure() {
	return this.changeTo(this.defaultInstance("bank.state.CheckBalanceFailureState"));
}
/**
 * 
 * @return bank.state.ATMState
 */
public State beDepositFailure() {
	return this.changeTo(this.defaultInstance("bank.state.DepositFailureState"));
}
/**
 * 
 * @return bank.state.ATMState
 */
public State beOverWithdraw() {
	return this.changeTo(this.defaultInstance("bank.state.OverWithdrawState"));
}
/**
 * 
 * @return bank.state.ATMState
 */
public State beShowingAccount() {
	return this.changeTo(this.defaultInstance("bank.state.ShowingAccountState"));
}
/**
 * 
 * @return bank.state.ATMState
 */
public State beWithdrawFailure() {
	return this.changeTo(this.defaultInstance("bank.state.WithdrawFailureState"));
}
/**
 * 
 * @param anATMGui bank.gui.ATMGui
 */
public State cancel() {
		//default do nothing
		return null;
}
/**
 * 
 * @param newState bank.util.State
 */
public State changeTo(State newState) {
	((BaseAtmGuiState)newState).setAtmGuiLogic(logic);
	((BaseAtmGuiState)newState).setAccountNumber(accountNumber);
	((BaseAtmGuiState)newState).setBalance(balance);
	return super.changeTo(newState);
}
/**
 * 
 * @return int
 */
public int getAccountNumber() {
	return accountNumber;
}
/**
 * 
 * @return bank.gui.AtmGuiLogic
 */
public AtmGuiLogic getAtmGuiLogic() {
	return logic;
}
/**
 * 
 * @return int
 */
public int getBalance() {
	return balance;
}
/**
 * 
 * @param logic bank.gui.AtmGuiLogic
 */
public void setAccountNumber(int accountNumber) {
	this.accountNumber = accountNumber;
}
/**
 * 
 * @param logic bank.gui.AtmGuiLogic
 */
public void setAtmGuiLogic(AtmGuiLogic logic) {
	this.logic = logic;
}
/**
 * 
 * @param logic bank.gui.AtmGuiLogic
 */
public void setBalance(int balance) {
	this.balance = balance;
}
}