
package bank.storage;


/*
 * Copyright (C) 1998 OGIS-RI. All Rights Reserverd.
 *
 */

import java.util.*;
import java.sql.*;

import bank.util.*;

/**
 *JDBC𗘗pāA[Vif[^x[XɃIuWFNg̃f[^
 *i[Ďgpꍇ̃f[^x[XA_v^
 *hCfŗL̃A_v^ɂȂȂ悤ɂ邽߂bank.storage.JdbcTableMapper
 *strategyƂĎgp
 *#pattern: Adaptor
 *#pattern: Strategy
 *
 *@see bank.storage.JdbcTableMapper
 *@version 3.2 
 *@author Masashi Umezawa
 */
public class JdbcRdbAdaptor extends DbAdaptor {
	static protected Hashtable TableMapperDict = new Hashtable();
	
	protected JdbcSessionManager sessionMgr;
	protected JdbcTableMapper mapper;
	
	protected String driverKind;
	protected String dbLocation;
	protected String username;
	protected String password;
	









/**
 * 
 */
public JdbcRdbAdaptor ( ) {
	sessionMgr = (JdbcSessionManager)(SingletonFactory.defaultInstance("bank.storage.JdbcSessionManager"));
}
/**
 * 
 * @param targetDomain java.lang.Object
 */
public JdbcRdbAdaptor ( Object targetDomain) {
	super(targetDomain);
	sessionMgr = (JdbcSessionManager)(SingletonFactory.defaultInstance("bank.storage.JdbcSessionManager"));
	mapper = this.getTableMapperOf(((RdbTableMappable)targetDomain).mapperClassName());
}
/**
 * 
 */
public void createMapper() {
	//default do nothing
}
/**
 * 
 * @return bank.storage.RdbTableMapper
 * @param mapperName java.lang.String
 */
static public JdbcTableMapper createMapperOf(String mapperName) {
	JdbcTableMapper newMapper = null;
	try {
		newMapper = (JdbcTableMapper)(Class.forName(mapperName)).newInstance();
 	} catch (ClassNotFoundException e ){
 		e.printStackTrace();
 	} catch (InstantiationException e ){
 		e.printStackTrace();
 	} catch (IllegalAccessException e ){
 		e.printStackTrace();
 }
 return newMapper;
}
/**
 * 
 */
public static Hashtable defaultTableMapperDict() {
	return TableMapperDict;
}
/**
 * 
 * @param mapperName java.lang.String
 */
public static JdbcTableMapper getTableMapperOf(String mapperName) {
	Object obj;
	Hashtable dict;
	dict = defaultTableMapperDict();
	obj = dict.get(mapperName);
	
	if(obj == null){
				obj = createMapperOf(mapperName);
				dict.put(mapperName, obj);
	}
		return (JdbcTableMapper)obj;
}
/**
 * 
 */
public void install( ){
	sessionMgr.createSessions(driverKind, dbLocation);
	try{
		sessionMgr.startSessions(username, password);
	} catch (SQLException e){
		System.out.println("**failed to start session");
		System.out.println("username: " + username);
		System.out.println("password: " + password);
	}		
}
	/**
	 * bank.storage.DBAdaptor stuff
	 */
synchronized public Object retrieve( Object idValue) throws NotFoundException{
	Object o = null;
	try {
		JdbcSession session = sessionMgr.getSession();
		String query = mapper.selectQuery(idValue);
		o = mapper.fromResultSet(session.executeQuery(query));
	} catch (SQLException e) {
		System.out.println("**failed to retrieve");
		e.printStackTrace();
		throw new NotFoundException();
	} catch (NotFoundException e) {
		System.out.println("**cannot find from db");
		e.printStackTrace();
		throw e;
	}
	return o;
}
/**
 * 
 */
protected void setAllEnvironmentSettings() {
	  driverKind = System.getProperty("storage.jdbc.driverKind");
	  dbLocation = System.getProperty("storage.jdbc.dbLocation");
}
/**
 * 
 * @param username java.lang.String
 */
public void setDbLocation(String dbLocation) {
	this.dbLocation = dbLocation;
}
/**
 * 
 * @param username java.lang.String
 */
public void setDriverKind(String driverKind) {
	this.driverKind = driverKind;
}
public void setEnvironmentSettings(String propertyName)  {
	String result;
	if ( propertyName.equals("storage.jdbc.driverKind")) {
	  result = System.getProperty("storage.jdbc.driverKind");
	  if ( result == null ) { driverKind = "sun.jdbc.odbc.JdbcOdbcDriver";}
	  else { driverKind = result;}
  	} else if ( propertyName.equals("storage.jdbc.dbLocation")) {
	  result = System.getProperty("storage.jdbc.dbLocation");
	  if ( result == null ) { dbLocation = "jdbc:odbc:bank";}
	  else { dbLocation = result;}
  	}
}
/**
 * 
 * @param username java.lang.String
 */
public void setPassword(String password) {
	this.password = password;
}
/**
 * 
 * @return bank.storage.RdbTableMapper
 * @param mapperName java.lang.String
 */
public void setRdbMapperTo(String mapperName) {
	mapper = this.getTableMapperOf(mapperName);
}
/**
 * 
 * @param username java.lang.String
 */
public void setUsername(String username) {
	this.username = username;
}
	/**
	 * bank.storage.DBAdaptor stuff
	 */
synchronized public void store( Object o, Object idValue) {
	String key = this.getIdString(idValue);
	JdbcSession session = sessionMgr.getSession();
		try {
			String query = mapper.updateQuery(key, o);
			session.executeUpdate(query);
			session.commit();
		} catch ( SQLException e) {
			System.out.println("**failed to update");
			try{ session.rollback();
		} catch (SQLException rollbackError){
				rollbackError.printStackTrace();
		}	
			e.printStackTrace();
   		}
} 
}