
package bank.storage;


/*
 * Copyright (C) 1998 OGIS-RI. All Rights Reserverd.
 *
 */

import java.sql.*;
import java.util.*;
import java.io.*;

/**
 *JDBCւ̐ڑAؒfȒPɍs߂̃NX
 *1CX^XARDBɑ΂1ڑ\B(ZbVƌĂł)
 *
 *#pattern: Facade
 *
 *@version 3.2 
 *@author Masashi Umezawa
 */
public class JdbcSession {
	
	protected String dbLocation;
	protected String driverKind;
	
	protected Connection connection;
	protected Statement statement;
	protected PreparedStatement preparedStatement;
	protected ResultSet resultSet;
	
	protected boolean isAutoCommit = true;
	protected boolean isVerbose = false;
	










/**
 * 
 */
public JdbcSession ( ) {
	
}
/**
 * 
 * @param dBurl java.lang.String
 */
public JdbcSession (String dbUrl) {
	this("sun.jdbc.odbc.JbdcOdbcDriver", dbUrl );
}
/**
 * 
 * @param dbUrl java.lang.String
 * @param driverKind java.lang.String
 */
public JdbcSession ( String driverKind, String dbLocation) {
	this.driverKind = driverKind;
	this.dbLocation = dbLocation;
}
/**
 * 
 */
public void beAutoCommit (boolean trueOrNot ) {
	isAutoCommit = trueOrNot;
}
/**
 * 
 */
public void beVerbose (boolean trueOrNot ) {
	isVerbose = trueOrNot;
}
public void commit() throws SQLException
{
	if( !isAutoCommit ) {
		connection.commit();
	}	 
}
/**
 * 
 */
public void end ( ) {
	try {
		if(connection != null){
			connection.close();
			connection = null;
		}	
		if(statement != null){
			statement.close();
			statement = null;
		}
		if(preparedStatement != null){
			preparedStatement.close();
			preparedStatement = null;
		}
		if(resultSet != null){
			resultSet.close();
			resultSet = null;
		}
	} catch (SQLException e){
		this.reportError(e);
	}	
}
public ResultSet executeQuery() throws SQLException
{
		resultSet = preparedStatement.executeQuery();
		return resultSet;
}
public ResultSet executeQuery(String query) throws SQLException
{
		resultSet = statement.executeQuery(query);
		return resultSet;
}
public int executeUpdate() throws SQLException
{
	return preparedStatement.executeUpdate();
}
public int executeUpdate(String query) throws SQLException
{
	return statement.executeUpdate(query);
}
/**
 * 
 */
public void finalize() throws Throwable{
	this.end();
	super.finalize();
}
public Connection getConnection()
{
	return connection;
}
/**
 * 
 * @return java.lang.String
 */
public String getDbLocation ( ) {
	return dbLocation;
}
/**
 * 
 * @return java.lang.String
 */
public String getDriverKind ( ) {
	return driverKind;
}
public Statement getStatement()
{
	return statement;
}
/**
 * 
 * @param e java.sql.SQLException
 */
protected void reportError(SQLException e){
	if(isVerbose){
		System.out.println (e.getClass().getName());
 		while (e != null) {
   		System.out.println ("##SQLState: " + e.getSQLState ());
 			System.out.println ("##Message:  " + e.getMessage ());
 			System.out.println ("##Vendor:   " + e.getErrorCode ());
			e = e.getNextException ();
 			System.out.println ("");
   }
  }		
}
public void rollback() throws SQLException
{
	if( !isAutoCommit ){
		connection.rollback();
	} 
}
/**
 * 
 * @param driverKind java.lang.String
 */
public void setDbLocation(String dbLocation) {
	this.dbLocation = dbLocation;
}
/**
 * 
 * @param driverKind java.lang.String
 */
public void setDriverKind(String driverKind) {
	this.driverKind = driverKind;
}
/**
 * 
 */
public void start( String username, String passwd) throws SQLException{
		try{
			Class.forName(driverKind);
			connection = DriverManager.getConnection( dbLocation, username, passwd );
			statement = connection.createStatement ();
		}
		catch( ClassNotFoundException e ){
			e.printStackTrace();
		}	
		catch( SQLException e ){
			this.end();
			this.reportError(e);
		}
}
}