
package bank.storage;


/*
 * Copyright (C) 1998 OGIS-RI. All Rights Reserverd.
 *
 */

import java.util.*;
import java.sql.*;

/**
 *bank.storage.JdbcSession 悭Ǘ邽߂̃}l[WNX
 *ʂRDBɑ΂ڑ̊m̓RXg邽߂ɁAJdbcSession
 *CX^Xv[AsKvȐڑ̊mAؒfȂ悤ɂĂ
 *ftHg̃ZbV 5
 *#pattern: Wrapper
 *
 *@version 3.2 
 *@author Masashi Umezawa
 */
public class JdbcSessionManager {
	protected Vector sessions;	
	protected int sessionCount;
	protected int maxSessionIndex;
	protected boolean isSessionCreated;
	
	protected String dbLocation;
	protected String driverKind;
	protected boolean isAutoCommit;









/**
 * 
 */
public JdbcSessionManager ( ) {
	this(5);
}
/**
 * 
 * @param numberOfSessions int
 */
public JdbcSessionManager (int numberOfSessions) {
	sessions = new Vector(numberOfSessions);
	this.maxSessionIndex = sessions.capacity();
	this.sessionCount = 0;
	this.isAutoCommit = false;
	this.isSessionCreated = false;
}
/**
 * 
 * @param numberOfSessions int
 */
public JdbcSessionManager (int numberOfSessions, String driverKind, String dbLocation) {
	sessions = new Vector(numberOfSessions);
	maxSessionIndex = sessions.capacity();
	sessionCount = 0;
	
	this.driverKind = driverKind;
	this.dbLocation = dbLocation;
	this.isAutoCommit = false;
	this.isSessionCreated = false;
}
/**
 * 
 */
public JdbcSessionManager ( String driverKind, String dbLocation) {
	this(5, driverKind, dbLocation);
}
/**
 * 
 * @param tureOrNot boolean
 */
public void beAutoCommit(boolean trueOrNot) {
	this.isAutoCommit = trueOrNot;
}
/**
 * 
 */
public void createSessions() {
	if(!isSessionCreated){
		JdbcSession se;
		for(int i=0; i< sessions.capacity(); i++){
			se = new JdbcSession(driverKind, dbLocation);
			se.beAutoCommit(isAutoCommit);
			sessions.addElement(se);
		}
		isSessionCreated = true;
	}		
}
/**
 * 
 */
public void createSessions(String driverKind, String dbLocation) {
	if(!isSessionCreated){
		JdbcSession se;
		for(int i=0; i< sessions.capacity(); i++){
			se = new JdbcSession(driverKind, dbLocation);
			se.beAutoCommit(isAutoCommit);
			sessions.addElement(se);
		}
		isSessionCreated = true;
	}	
}
/**
 * 
 */
public void endSessions( ) {
	Enumeration enu = sessions.elements();
	while(enu.hasMoreElements()){
		((JdbcSession)enu.nextElement()).end();
	}	
}
protected void finalize() throws Throwable { 
	this.endSessions();	
}
/**
 * 
 * @return RdbSession
 */
public JdbcSession getSession() {
	JdbcSession se;
	
	//System.out.println("##sessions");
	//System.out.println(sessions);
	//System.out.println("##sessioncount");
	//System.out.println(sessionCount);
	
	se = (JdbcSession)(sessions.elementAt(sessionCount));
	sessionCount = sessionCount + 1;
	if(sessionCount >= maxSessionIndex){
		sessionCount = 0;
	}	
	return se;
}
/**
 * 
 * @param dbLocation java.lang.String
 */
public void setDbLocation(String dbLocation) {
	this.dbLocation = dbLocation;
}
/**
 * 
 */
public void setDriverKind (String driverKind ) {
	this.driverKind = driverKind;
}
/**
 * 
 */
public void startSessions(String username, String passwd ) throws SQLException{
	Enumeration enu = sessions.elements();
	while(enu.hasMoreElements()){
		((JdbcSession)enu.nextElement()).start(username, passwd);
	}	
}
}