
package bank.storage;


/*
 * Copyright (C) 1998 OGIS-RI. All Rights Reserverd.
 *
 */

import java.util.*;
import bank.model.*;
import bank.util.*;

/**
 *Storager̋@\eXg邽߂̃NX
 *
 *@version 3.2 
 *@author Masashi Umezawa
 */
public class StorageTest {














public static void main(String args[]){
	try {
	    test1();
	    test2();
	} catch (NotFoundException e){
	    e.printStackTrace();
	}
}
public static void test1() throws NotFoundException {
	System.out.println("test1");
 	Account account1, account2, targetDomain;
	FileBaseDbAdaptor adaptor;
	Storager storager;
	
	account1 = new Account();
	account1.setNumber(1);
	account1.setBalance(0);
	
	//set adaptor
	adaptor = new TextFileDbAdaptor(targetDomain = new Account());
	adaptor.setEnvironmentSettings("storage.pathname");
	storager = new ObserveStorager( account1, adaptor);
	System.out.println(account1.countObservers());
	
	//set balance
	account1.setBalance(1000);
	System.out.println("account1->" + account1.getBalance());
	
	//retieve
	account2 = (Account)adaptor.retrieve((Object)(new Integer(1)));
	System.out.println("account2->" + account2.getBalance());
	
}
public static void test2() throws NotFoundException{
	
	System.out.println("test2");
		
	Account account1, account2;
	FileBaseDbAdaptor adaptor;
	Storager storager;
	
	account1 = new Account();
	account1.setNumber(1);
	account1.setBalance(0);
	
	//set adaptor(Serialization)
	adaptor = new SerializationDbAdaptor();
	adaptor.setEnvironmentSettings("storage.pathname");
	storager = new ObserveStorager( account1, adaptor);
	System.out.println(account1.countObservers());
	
	//set balance
	account1.setBalance(1000);
	
	System.out.println("account1->" + account1.getBalance());
	
	//retieve
	account2 = (Account)adaptor.retrieve((Object)(new Integer(1)));
	System.out.println("account2->" + account2.getBalance());
	
}
}